<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:rich="http://richfaces.org/rich" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns="http://www.w3.org/1999/xhtml"
                template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalForm">
            <h1>Constraints Management</h1>

            <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                <ui:define name="panel_title">Import constraints file (XML)</ui:define>
                <rich:fileUpload id="uploadFile"
                                 fileUploadListener="#{consDefManager.uploadListener}"
                                 maxFilesQuantity="1"
                                 acceptedTypes="xml" listHeight="60px"
                                 immediateUpload="true">
                    <a4j:ajax event="uploadcomplete" oncomplete="#{consDefManager.displayImportButton()}" render="footerConstraints"/>
                </rich:fileUpload>
                <ui:define name="panel_footer">
                    <s:div id="footerConstraints">
                        <s:div rendered="#{consDefManager.displayImportButton()}">
                            <a4j:commandButton value="Import new constraints"
                                               id="deleteAllActionButton"
                                               onclick="jq162('#deleteAllPopup').modal('show');"
                                               render="messageDecoration,listpackdiv"
                                               styleClass="gzl-btn-blue"/>
                        </s:div>
                    </s:div>
                </ui:define>

                <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                    <ui:param name="popup_id" value="deleteAllPopup"/>
                    <ui:param name="styleClass" value="modal-sm"/>
                    <ui:param name="headerStyleClass" value="gzl-text-red"/>
                    <ui:define name="popup_title">
                        <span class="fa fa-exclamation-triangle"></span>
                        Import new constraints ?
                    </ui:define>
                    <ui:param name="bodyStyleClass" value="bg-warning"/>
                    <p>New imported constraints will override the old ones. Are you sure you want to import new
                        constraints from the XML file ?</p>
                    <ui:define name="popup_footer">
                        <a4j:commandButton value="Yes"
                                           actionListener="#{consDefManager.deleteAndGenerate()}"
                                           oncomplete="jq162('#deleteAllPopup').modal('hide');"
                                           render="listpackdiv,messageDecoration"
                                           styleClass="gzl-btn-red"/>
                        <a4j:commandButton value="No"
                                           styleClass="gzl-btn"
                                           oncomplete="jq162('#deleteAllPopup').modal('hide');"/>
                    </ui:define>
                </ui:decorate>
            </ui:decorate>
            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                <ui:define name="panel_title">
                    Constraints Management
                </ui:define>
                <s:div id="listpackdiv">
                    <rich:dataTable id="templTablPack" rendered="#{consDefManager.hasAvailablePackages()}"
                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                    value="#{consDefManager.getAvailablePackages()}" var="currentPack"
                                    render="ds">
                        <g:column filterBy="#{'name'}" sortBy="#{'name'}" sortOrder="ascending">
                            <ui:define name="header">name</ui:define>
                            <h:outputLink value="../constraints/constraints.seam?package=#{currentPack.name}" target="_blank">
	                            <h:outputText value="#{currentPack.name}"/>
	                        </h:outputLink>
                        </g:column>
                        <g:column filterBy="#{'packageName'}">
                            <ui:define name="header">packageName</ui:define>
                            <h:outputText value="#{currentPack.packageName}"/>
                        </g:column>
                        <g:column sortBy="#{xmlNamespace}">
                            <ui:define name="header">namespace</ui:define>
                            <h:outputText value="#{currentPack.xmlNamespace}"/>
                        </g:column>
                        <g:column filterBy="#{'description'}">
                            <ui:define name="header">description</ui:define>
                            <h:outputText value="#{currentPack.description}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">standards</ui:define>
                            <a4j:repeat value="#{currentPack.standards}" var="stand">
                                <h:outputText value="#{stand} "/>
                            </a4j:repeat>
                        </g:column>
                        <g:column filterBy="#{'lastUpdated'}" sortBy="#{'lastUpdated'}">
                            <ui:define name="header">last update</ui:define>
                            <g:date date="true" time="true" value="#{currentPack.lastUpdated}" tooltip="false"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">action</ui:define>
                            <a4j:commandLink id="deleteActionButton"
                                             action="#{consDefManager.setSelectedPackage(currentPack)}"
                                             render="deleteTextDiv"
                                             onclick="jq162('#deletePopup').modal('show');">
                                <span class="gzl-icon-trash-o"></span>
                            </a4j:commandLink>
                            <h:commandLink id="downloadAct"
                                           action="#{consDefManager.downloadPackage(currentPack)}">
                                <span class="gzl-icon-download"></span>
                            </h:commandLink>
                        </g:column>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="ds"/>
                                <ui:param name="dataTableId" value="templTablPack"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                </s:div>
            </ui:decorate>
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="deletePopup"/>
                <ui:param name="styleClass" value="modal-sm"/>
                <ui:param name="headerStyleClass" value="gzl-text-red"/>
                <ui:define name="popup_title">
                    <span class="fa fa-exclamation-triangle"></span>
                    Delete package ?
                </ui:define>
                <ui:param name="bodyStyleClass" value="bg-warning"/>
                <s:div id="deleteTextDiv">
                    <h:outputText value="Are you sure to delete the package named #{consDefManager.selectedPackage.name} ?"/>
                </s:div>
                <ui:define name="popup_footer">
                    <a4j:commandButton value="Cancel"
                                       styleClass="gzl-btn"
                                       oncomplete="jq162('#deletePopup').modal('hide');"/>
                    <a4j:commandButton value="Delete"
                                       action="#{consDefManager.deleteSelectedPackage()}"
                                       oncomplete="jq162('#deletePopup').modal('hide');"
                                       render="listpackdiv,messageDecoration"
                                       styleClass="gzl-btn-red"/>
                </ui:define>
            </ui:decorate>
        </h:form>
    </ui:define>
</ui:composition>